from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes
from Products.SimpleFolder.config import PROJECTNAME, GLOBALS


def addToFactoryTool(self, out):
     print >> out, 'portal_factory modifications started.'
     
     ftool = getToolByName(self, 'portal_factory')
     
     if ftool:
          portal_factory_types = ftool.getFactoryTypes().keys()
               
     for portalType in [ typeDict['portal_type'] for typeDict in listTypes(PROJECTNAME) ]:
          if portalType not in portal_factory_types:
               portal_factory_types.append(portalType)
               ftool.manage_setPortalFactoryTypes(listOfTypeIds=portal_factory_types)
               print >> out, '    %s now uses portal_factory' % portalType
                    
     print >> out, 'portal_factory modifications done.'


def install(self):
     """Install content types, enable the portal factory"""

     out = StringIO()

     print >> out, "Installing %s" % PROJECTNAME

     # Install types
     classes = listTypes(PROJECTNAME)
     installTypes(self, out,
                  classes,
                  PROJECTNAME)
     print >> out, "Installed types"
     
     addToFactoryTool(self, out)     
        
     return out.getvalue()
